Attribute VB_Name = "Module1"
Global EinheitDateigre As Integer
Global ZahlenTrennpunkt As Boolean
Global ErfolgreichMeldung As Boolean
Global FensterMaximieren As Boolean
Global Vorschau As Boolean
Global Genauigkeit As Integer
Global Kompressionsrate As Integer

'Windows-API Funktionen fr Dateidialoge definieren
Declare Function DateiSpeichernDLG Lib "comdlg32" Alias "GetSaveFileNameA" (DatOpt As DateiOptionen) As Long
Declare Function DateiLadenDLG Lib "comdlg32" Alias "GetOpenFileNameA" (DatOpt As DateiOptionen) As Long

'Struktur fr Dateien
Type DateiOptionen
    lStructSize As Long
    hWndOwner As Long
    hInstance As Long
    lpstrFilter As String
    lpstrCustomFilter As String
    nMaxCustFilter As Long
    nFilterIndex As Long
    lpstrFile As String
    nMaxFile As Long
    lpstrFileTitle As String
    nMaxFileTitle As Long
    lpstrInitialDir As String
    lpstrTitle As String
    Flags As Long
    nFileOffset As Integer
    nFileExtension As Integer
    lpstrDefExt As String
    lCustData As Long
    lpfnHook As Long
    lpTemplateName As String
End Type

'Funktion zum Anzeigen des "Speichern"-Dialogs von Windows
Public Function DateiSpeichern(ByVal InitialDir$) As String

Dim DatOpt As DateiOptionen
With DatOpt
    .lStructSize = Len(DatOpt)
    .lpstrFilter = "JPG-Grafik (.jpg)" & vbNullChar & "*.jpg" & vbNullChar
    .lpstrFile = String$(500, vbNullChar)
    .nMaxFile = 500
    .lpstrFileTitle = String$(250, vbNullChar)
    .nMaxFileTitle = 250
    .lpstrInitialDir = InitialDir$
    .lpstrTitle = "Grafik speichern"
End With

If DateiSpeichernDLG(DatOpt) Then
    Dateiname = DatOpt.lpstrFile
    pos = InStr(Dateiname, vbNullChar)
    If pos > 1 Then
        DateiSpeichern = Left(Dateiname, pos - 1)
    Else
      DateiSpeichern = ""
    End If
Else
    DateiSpeichern = ""
End If

End Function

'Funktion zum Anzeigen des "ffnen"-Dialogs von Windows
Public Function DateiLaden(ByVal InitialDir$) As String

Dim DatOpt As DateiOptionen
With DatOpt
    .lStructSize = Len(DatOpt)
    .lpstrFilter = "JPG-Grafiken (.jpg)" & vbNullChar & "*.jpg" & vbNullChar
    .lpstrFile = String$(500, vbNullChar)
    .nMaxFile = 500
    .lpstrFileTitle = String$(250, vbNullChar)
    .nMaxFileTitle = 250
    .lpstrInitialDir = InitialDir$
    .lpstrTitle = "Grafik laden"
End With

If DateiLadenDLG(DatOpt) Then
    Dateiname = DatOpt.lpstrFile
    pos = InStr(Dateiname, vbNullChar)
    If pos > 1 Then
        DateiLaden = Left(Dateiname, pos - 1)
    Else
      DateiLaden = ""
    End If
Else
    DateiLaden = ""
End If

End Function

'Funktion zum Umwandeln einer Zahl in eine durch "." getrennte
'Zahl (also statt 5820463  eben  5.820.463)
Public Function Zahlmit1000erTrennzeichen(Zahl As Variant)
    Dim s, s2 As String
    s = CStr(Zahl)
    s = StrReverse(s)
    For i = 1 To Len(s)
        s2 = s2 + Mid(s, i, 1)
        If (i Mod 3 = 0 And i <> Len(s)) Then s2 = s2 + "."
    Next i
    Zahlmit1000erTrennzeichen = StrReverse(s2)
End Function
